package com.sw.domain.po;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.annotation.Id;
import org.springframework.data.elasticsearch.annotations.Document;
import org.springframework.data.elasticsearch.annotations.Field;
import org.springframework.data.elasticsearch.annotations.FieldType;

/**
 * 商品
 *
 * @author yegang
 * @create 2022-03-10 9:55
 **/
@Data
@AllArgsConstructor
@NoArgsConstructor
@Document(indexName = "jd_list")
public class EsProduct {
    @Id  //主键
    private Integer id;
    //FieldType.Auto根据字段类型自动注入,例如这里是String
    @Field(type = FieldType.Keyword)
    private String name;
    //FieldType.Auto根据字段类型自动注入,例如这里是String
    @Field(type = FieldType.Auto)
    private String url;
    @Field(type = FieldType.Auto)
    private String price;

    @Field(type = FieldType.Integer,index = false)
    private Integer num;
}
