package com.sw.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.sw.dao.SysTest2Dao;
import com.sw.domain.SysTest2;
import com.sw.service.SysTest2Service;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;

/**
 * (SysTest2)表服务实现类
 *
 * @author yegang
 * @since 2022-02-25 15:52:47
 */
@Service("sysTest2Service")
public class SysTest2ServiceImpl extends ServiceImpl<SysTest2Dao, SysTest2> implements SysTest2Service {
    @Resource
    private SysTest2Dao sysTest2Dao;


    @Override
    @Transactional(rollbackFor = Exception.class,propagation = Propagation.REQUIRED)
    public void addTest20(SysTest2 sysTest2) {
         sysTest2Dao.insert(sysTest2);
    }

    @Override
    @Transactional(rollbackFor = Exception.class,propagation = Propagation.REQUIRED)
    public void addTest21(SysTest2 sysTest2) throws Exception {
         sysTest2Dao.insert(sysTest2);
         throw new Exception();
    }
    @Override
    @Transactional(rollbackFor = Exception.class,propagation = Propagation.REQUIRES_NEW)
    public void addTest22(SysTest2 sysTest2) {
         sysTest2Dao.insert(sysTest2);
    }

    @Override
    @Transactional(rollbackFor = Exception.class,propagation = Propagation.REQUIRES_NEW)
    public void addTest23(SysTest2 sysTest2) throws Exception {
         sysTest2Dao.insert(sysTest2);
        throw new Exception();

    }

    @Override
    @Transactional(rollbackFor = Exception.class,propagation = Propagation.NESTED)
    public void addTest24(SysTest2 sysTest2) {
        sysTest2Dao.insert(sysTest2);
    }

    @Override
    @Transactional(rollbackFor = Exception.class,propagation = Propagation.NESTED)
    public void addTest25(SysTest2 sysTest2) throws Exception {
        sysTest2Dao.insert(sysTest2);
        throw new Exception();

    }
}