package com.sw.util;

import com.sw.domain.po.EsProduct;
import org.jsoup.Connection;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.nodes.Element;
import org.jsoup.select.Elements;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Random;

/**
 * @author yegang
 * @create 2022-03-10 10:03
 **/
public class ParseHtml {
    public static List<EsProduct> parse(String name) throws IOException {
        String url ="https://search.jd.com/Search?keyword="+name;
        Document document = Jsoup.connect(url).get();
        Element j_goodsList = document.body().getElementById("J_goodsList");
        Elements elements = j_goodsList.getElementsByTag("li");
        List<EsProduct> list = new ArrayList<>();
        for (Element e :elements){
            String img =e.getElementsByTag("img").eq(0).attr("data-lazy-img");
            String price =e.getElementsByClass("p-price").text();
            String pname =e.getElementsByClass("p-name").text();
            EsProduct esProduct = new EsProduct();
            esProduct.setName(pname);
            esProduct.setPrice(price);
            esProduct.setUrl(img);
            esProduct.setNum(new Random().nextInt(1000));
            list.add(esProduct);
        }
        return  list;
    }
}
