package com.sw;

import java.util.Optional;

import com.sw.dao.ResourceCommentRepository;
import com.sw.domain.ResourceComment;
import com.sw.service.ResourceCommentService;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.data.domain.Example;
import org.springframework.test.context.junit4.SpringRunner;
 

@RunWith(SpringRunner.class)
@SpringBootTest
public class ResourceCommentTests {
 
	@Autowired
	private ResourceCommentRepository resourceCommentRepository;
	
	@Autowired
	private ResourceCommentService resourceCommentService;
	
	@Before
	public void setUp() {
		
	}
	
	/**
	 * 测试评论
	 */
	@Test
	public void testSaveComment() {
		Long resourceId = 1L;
		Long commentUserId = 1L;
		String commentUserName = "用户" + commentUserId;
		String commentContent =   "唐朝最有名的皇帝是李世民 " + System.currentTimeMillis();
		resourceCommentService.saveComment(resourceId, commentUserId, commentUserName, commentContent);
	}
	
	/**
	 * 测试评论回复
	 */
	@Test
	public void testSaveResponse() {
		String id = "6226ba6dc67ad134b608fd88";
		Long responseUserId = 2L;
		String responseUserName = "用户" + responseUserId;
		String responseContent =  "我不认为是李世明，我认为是武则天" + System.currentTimeMillis();
		
		resourceCommentService.saveResponse(id, responseUserId, responseUserName, responseContent);
	}
	/**
	 * 测试评论回复
	 */
	@Test
	public void testSaveResponse2() {
		String id = "6226ba6dc67ad134b608fd88";
		Long responseUserId = 3L;
		String responseUserName = "用户" + responseUserId;
		String responseContent =  "我不认为是李世明，我认为是李渊" + System.currentTimeMillis();

		resourceCommentService.saveResponse(id, responseUserId, responseUserName, responseContent);
	}
	/**
	 * 测试回复评论的评论
	 */
	@Test
	public void testSaveReply() {
		String id = "6226ba6dc67ad134b608fd88";
		Long responseUserId = 2L;
		int index = 0;
		String replyContent = "我不认为是武则天，我认为是李隆基" + System.currentTimeMillis();
		
		resourceCommentService.saveReply(id, responseUserId, index, replyContent);
	}
	
	@Test
	public void testFind() {
		ResourceComment rc = new ResourceComment();
		rc.setResourceId(1L);
		rc.setCommentUserId(1L);
		Example<ResourceComment> example = Example.of(rc);
		Optional<ResourceComment> optional = resourceCommentRepository.findOne(example);
		Assert.assertTrue(optional.isPresent());
		Assert.assertEquals("用户1", optional.get().getCommentUserName());
	}
	
	
}