package com.sw.propagation;

import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;
import org.springframework.test.context.web.WebAppConfiguration;

import java.util.concurrent.locks.ReentrantLock;

/**
 * 并发测试
 *
 * @author yegang
 * @create 2022-02-28 9:51
 **/
@RunWith(SpringJUnit4ClassRunner.class)
@SpringBootTest
@WebAppConfiguration
public class ConTest {
    @Test
    public void sync() {
        Object o = new Object();
        new Thread(() -> {
            synchronized (o) {
                System.out.println("异常前");
                int a = 1 / 0;
                System.out.println("异常后");
            }
        }).start();
        new Thread(() -> {
            synchronized (o) {
                System.out.println("异常前");
                int a = 1 / 0;
                System.out.println("异常后");
            }
        }).start();
    }

    @Test
    public void Lock() {
        ReentrantLock reentrantLock = new ReentrantLock();
        new Thread(() -> {
            reentrantLock.lock();
            System.out.println("异常前");
            int a = 1 / 0;
            System.out.println("异常后");
            reentrantLock.unlock();
        }).start();
        new Thread(() -> {
            reentrantLock.lock();
            System.out.println("异常前");
            int a = 1 / 0;
            System.out.println("异常后");
            reentrantLock.unlock();
        }).start();

    }
    @Test
    public void tryLock() {
        ReentrantLock reentrantLock = new ReentrantLock();
        new Thread(() -> {
            reentrantLock.lock();
            try {
                System.out.println("异常前");
                int a = 1 / 0;
                System.out.println("异常后");
            }catch (Exception e){
                e.printStackTrace();
            }finally {
                reentrantLock.unlock();
            }
        }).start();
        new Thread(() -> {
            reentrantLock.lock();
            try {
                System.out.println("异常前");
                int a = 1 / 0;
                System.out.println("异常后");
            }catch (Exception e){
                e.printStackTrace();
            }finally {
                reentrantLock.unlock();
            }
        }).start();


    }
}
